<?php
/**
 * A region map manager
 *
 * @author		Roland Haeder <webmaster@ship-simu.org>
 * @version		0.0.0
 * @copyright	Copyright (c) 2015, 2016 City Developer Team
 * @license		GNU GPL 3.0 or any newer version
 * @link		http://www.ship-simu.org
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
class RegionMapManager extends BaseManager implements ManageableRegionMap {
	/**
	 * Protected constructor
	 *
	 * @return	void
	 */
	protected function __construct () {
		// Call parent constructor
		parent::__construct(__CLASS__);
	}

	/**
	 * Creates an instance of this class
	 *
	 * @return	$managerInstance	An instance of a ManageableRegion class
	 */
	public final static function createRegionMapManager () {
		// Get new instance
		$managerInstance = new RegionMapManager();

		// Get database wrapper
		$wrapperInstance = DatabaseWrapperFactory::createWrapperByConfiguredName('region_map_db_wrapper_class');

		// And set it here
		$managerInstance->setWrapperInstance($wrapperInstance);

		// Return the prepared instance
		return $managerInstance;
	}

	/**
	 * Creates a map, if not found yet, for given result which should contain
	 * data about the region in question
	 *
	 * @param	$resultInstance		Region result instance
	 * @return	void
	 */
	public function createRegionMapByResult (SearchableResult $resultInstance) {
		die('!ok');
	}
}

// [EOF]
?>
